dialog filter {
  title "Filter Editor - FuSioN <FuSioN@dfect.com> http://www.gznx.net"
  size -1 -1 600 350
  button "Done",1, 255 310 85 30, ok
  box "IN",2, 5 5 4 335
  box "OUT",3, 350 5 4 335
  box "Controls",4, 240 5 4 335

  button "Load IN",5,255 30 85 30
  button "Save OUT",6, 255 70 85 30

  edit "No IN file loaded!",7,15 25 215 315, hsbar vsbar return multi
  edit "",8, 360 25 215 315, hsbar vsbar return multi

  text "Filter...",9,255 110 50 20
  radio "Include",10, 255 130 60 20
  radio "Exclude",11,255 150 60 20
  edit "",12,255 170 85 20, autohs
  button "Filter It!",13, 255 195 85 30,default
  button "OUT -> IN",14,255 235 85 20
  button "Clear IN",15,255 255 85 20
  button "Clear OUT",16,255 275 85 20
}
alias filter.editor {
  if ($dialog(filter) == $null) dialog -md filter filter 
}
on *:DIALOG:filter:edit:*: {
  if ($did == 7) did -a filter 2 IN - $did(7).lines lines
  if ($did == 8) did -a filter 3 OUT - $did(8).lines lines
}
menu menubar {
  -
  Filter Editor
  .Open Editor: filter.editor
  .$iif(%filter.editor.autoclear != $true,Enable,Disable) AutoClear: set %filter.editor.autoclear $$?!="Auto clear old text from OUT box when Filter button is pressed?"
  -
}
alias -l UNLOAD-filter {
  unset %filter.editor.autoclear %filter.error %filter.filename
  echo 4 -a *** Unloaded Filter Editor v1 by FuSioN <fusion@dfect.com> http://www.gznx.net
  .timer 1 1 unload -rs $script
}
on *:DIALOG:filter:sclick:*: {
  if ($did == 5) .timer -m 1 1 filter.loadbuf 
  if ($did == 6) .timer -m 1 1 filter.savebuf
  if ($did == 15) { did -r filter 7 | did -a filter 2 IN | did -a filter 7 No IN file loaded! }
  if ($did == 16) { did -r filter 8 | did -a filter 3 OUT }
  if ($did == 14) { did -r filter 7 | filter -io filter 8 filter 7 * | did -r filter 8 | did -a filter 3 OUT | did -a filter 2 IN - $did(7).lines lines }
  if ($did == 13) {
    if ($did(12).text == $null) { filter.error You first have to enter some text to filter! | halt }
    if ($did(7,1).text == No IN file loaded!) { filter.error You first need to load an IN file to filter from! | halt }
    if ($did(10).state == 0) && ($did(11).state == 0) { filter.error You need to select a filter method first! | halt }
    if (%filter.editor.autoclear) did -r filter 8
    if ($did(10).state) {
      filter -io filter 7 filter 8 $did(12).text
    }
    if ($did(11).state) {
      filter -xio filter 7 filter 8 $did(12).text
    }
    did -a filter 3 OUT - $did(filter,8).lines lines
  }
}
dialog filter.error {
  title "ERROR"
  size -1 -1 300 50
  button "Doh!",1,210 5 85 40, ok
  box "Error:",2, 5 5 4 40
  text "",3, 15 20 190 40
}
alias filter.error {
  if ($1)  {
    set %filter.error $1-
    dialog -mdo filter.error filter.error
    halt
  }
}
on *:DIALOG:filter.error:init:0: did -a filter.error 3 %filter.error
alias filter.savebuf {
  set -u0 %filter.filename $$dir="Enter File To Save" *.txt
  filter -i filter 8 " $+ %filter.filename $+ "  *
}
alias filter.loadbuf {
  set -u0 %filter.filename $$dir="Select File To Load" *.txt
  dialog -v filter
  did -r filter 7
  loadbuf -o filter 7 " $+ %filter.filename $+ "
  did -a filter 2 IN - $did(filter,7).lines lines
}
